/* dia-canvas (c) sus dueños.
 * dia-canvas-clipboard (c) 
 * Derechos reservados : RF-Labs. www.rflabs-online.com
 * Copyright (C) 2007 RF-Labs. www.rflabs-online.com
 * Ing. development:
 * Ing.Desarrollo Exell E. Franklin Jiménez.
 * Cumple con la licencia GNU 2 o superior.
 * GNULicense 2 or above.
 * Se basó en la biblioteca de gtkclipboard
 * based upon gtkclipboard
 * This librarie give gtkclipsupport to dia canvas objects
 * Esta biblioteca dá soporte de portapapeles a los objetos de dia-canvas
 */

#ifndef __DIA_CANVAS_CLIPBOARD_H__
#define __DIA_CANVAS_CLIPBOARD_H__

#include <gtk/gtk.h>
#include <gtk/gtkselection.h>
#include <gtk/gtkclipboard.h>
#include <diacanvas/dia-canvas-element.h>  /*El objeto pricipal*/
#include <diacanvas/dia-canvas-item.h>  /*El objeto pricipal*/
#include <diacanvas/dia-placement-tool.h>  /*El objeto pricipal*/


G_BEGIN_DECLS

#define DIA_TYPE_DIA_CANVAS_CLIPBOARD  (dia_canvas_clipboard_get_type ())
#define DIA_CANVAS_CLIPBOARD(obj)      (G_TYPE_CHECK_INSTANCE_CAST ((obj),DIA_TYPE_DIA_CANVAS_CLIPBOARD, DiaCanvasClipboard))
#define DIA_IS_DIA_CANVAS_CLIPBOARD(obj)    (G_TYPE_CHECK_INSTANCE_TYPE ((obj),DIA_TYPE_DIA_CANVAS_CLIPBOARD))


typedef struct _DiaCanvasClipboardClass DiaCanvasClipboardClass;
typedef struct _DiaCanvasClipboard      DiaCanvasClipboard; 

/*
 *Definición de los prototipos de las funciones
 * 
 *Definition functions_prototypes_for clipboard
 *
 */

typedef void (* DiaCanvasClipboardReceivedFunc)        (GtkClipboard     *clipboard,
					                void* info,void*  data);
typedef void (* DiaCanvasClipboardItemReceivedFunc)    (GtkClipboard     *clipboard,
					                DiaCanvasItem    *item,
					                gpointer          data);

typedef void (* DiaCanvasClipboardGetFunc)    (GtkClipboard     *clipboard,
					       GtkSelectionData *selection_data,
					       guint             info,
					       void*          user_data_or_owner);

typedef void (* DiaCanvasClipboardClearFunc)  (DiaCanvasClipboard     *clipboard,
					       gpointer          user_data_or_owner);


DiaTool* dia_canvas_clipboard_request_dia_item_b(DiaCanvasClipboard*);

struct _DiaCanvasClipboard 
{
  GObject object;
  GtkClipboard* gtk_clip;

  GdkAtom void_atom;

  DiaCanvasClipboardGetFunc get_func;
  DiaCanvasClipboardClearFunc clear_func;
  gpointer user_data;
  
  GQueue* cola; 
   GList* lista;
  gboolean have_selection;
  unsigned int obj_size;

};


struct _DiaCanvasClipboardClass
{
  GObjectClass parent_class;
};




/*funciones de glib.
 *glib considerations
*/
GType    dia_canvas_clipboard_get_type (void);



void     dia_canvas_clipboard_clear(DiaCanvasClipboard*);


/*
 * New DiaCanvasClipboard Object
*/
DiaCanvasClipboard* dia_canvas_clipboard_new();


/*
 *función que pone un ítme en el portapapeles de gtk.
 * function that puts a Item on the gtkclipboard
 * unsigned int: objects size (tamaño del objeto en bytes)
 * 
 */
void dia_canvas_clipboard_set_dia_item (DiaCanvasClipboard*,const DiaCanvasItem*,unsigned int);
/*
 *Función que pone cualquier cosa en el porta papeles
 *function that puts whatever thing on clipboard
 * unsigned int: objects size (tamaño del objeto en bytes)
*/
void dia_canvas_clipboard_set_void (DiaCanvasClipboard*,void*,unsigned int);

/*
 *function that recive a dia_item
 *Función que pide el diaItem
 * bemused
*/
void dia_canvas_clipboard_request_dia_item(DiaCanvasClipboard*, DiaCanvasClipboardReceivedFunc,gpointer);


/*
 *function that recive a void* object
 *Función que pide un obj genérico
*/
void dia_canvas_clipboard_request_void(DiaCanvasClipboard*, DiaCanvasClipboardReceivedFunc,gpointer);




  
G_END_DECLS

#endif /* __DIA_CANVAS_CLIPBOARD_H__ */
